# Contributing

Thanks for considering contributing to cncserver!

## Opening issues

If you find a bug, please feel free to [open an issue](https://github.com/techninja/cncserver/issues).

If you taking the time to mention a problem, even a seemingly minor one, it is greatly appreciated, and a totally valid contribution to this project. Thank you!

## Fixing bugs

We love pull requests. Here’s a quick guide:

1. [Fork this repository](https://github.com/techninja/cncserver/fork) and then clone it locally:

  ```bash
  git clone https://github.com/techninja/cncserver
  ```

2. Create a topic branch for your changes:

  ```bash
  git checkout -b fix-for-that-thing
  ```
3. Commit a failing test for the bug:

  ```bash
  git commit -am "Adds a failing test to demonstrate that thing"
  ```

4. Commit a fix that makes the test pass:

  ```bash
  git commit -am "Adds a fix for that thing!"
  ```

5. Run the tests:

  ```bash
  npm test
  ```

6. If everything looks good, push to your fork:

  ```bash
  git push origin fix-for-that-thing
  ```

7. [Submit a pull request.](https://help.github.com/articles/creating-a-pull-request)

8. Enjoy being the wonderful person you are

## Adding new features

Thinking of adding a new feature? Cool! [Open an issue](https://github.com/techninja/cncserver/issues) and let’s design it together.
